#ifndef _H_LIBCP_STRING
#define _H_LIBCP_STRING

#include "collections/vec.hpp"

class String {
private:
    Vec<char> _chars;

public:
    String() = default;
    ~String() = default;
    String(const char*);
    size_t len();
    void clear();
    Vec<char>& chars();
    char* const as_cstr();
    void push(char c);
    void push_str(String& str);
    // void push_str(String&& str);
    void push_str(const char* str);
    // IMPL: Format
    String fmt_to_str();
    // IMPL: Clone
    String clone();
};

#endif // _H_LIBCP_STRING