#ifndef _H_LIBCP_STL_IS_REFERENCEABLE
#define _H_LIBCP_STL_IS_REFERENCEABLE

#include <stl/void_t.hpp>

template <class _Tp, class = void>
inline const bool __is_referenceable_v = false;

template <class _Tp>
inline const bool __is_referenceable_v<_Tp, __void_t<_Tp&>> = true;

template <class _Tp>
concept __referenceable = __is_referenceable_v<_Tp>;

#endif // !_H_LIBCP_STL_IS_REFERENCEABLE
